/*******************************************************************
*  PAINTDLG.HXX
*  (c) 1992-1994 STAR DIVISION
*******************************************************************/

#ifndef _PAINTDLG_HXX
#define _PAINTDLG_HXX

#ifndef _SV_HXX
#include <sv.hxx>
#endif

// --- class PenDialog ---------------------------------------------

class PenDialog : public ModalDialog
{
private:
    FixedText       aColorText;
    ListBox         aColorList;
    FixedText       aWidthText;
    MetricField     aWidthField;
    FixedText       aStyleText;
    ListBox         aStyleList;
    OKButton        aOKButton;
    CancelButton    aCancelButton;
    Pen             aChoosePen;

public:
                    PenDialog( Window* pParent );

    Pen             ChangeChoosePen( const Pen& rPen );
    Pen             GetChoosePen() const { return aChoosePen; }

    void            OKHdl( OKButton* );
};

// --- class BrushDialog -------------------------------------------

class BrushDialog : public ModalDialog
{
private:
    FixedText       aColorText;
    ListBox         aColorList;
    FixedText       aFillColorText;
    ListBox         aFillColorList;
    FixedText       aStyleText;
    ListBox         aStyleList;
    CheckBox        aTransparentBox;
    OKButton        aOKButton;
    CancelButton    aCancelButton;
    Brush           aChooseBrush;

public:
                    BrushDialog( Window* pParent );

    Brush           ChangeChooseBrush( const Brush& rBrush );
    Brush           GetChooseBrush() const { return aChooseBrush; }

    void            OKHdl( OKButton* );
};

#endif // _PAINTDLG_HXX
