/*******************************************************************
*  PAINTWIN.HXX
*  (c) 1992-1994 STAR DIVISION
*******************************************************************/

#ifndef _PAINTWIN_HXX
#define _PAINTWIN_HXX

#ifndef _SV_HXX
#include <sv.hxx>
#endif

// --- class PaintDocWin -------------------------------------------

class PaintDocWin : public MDIWindow
{
private:
    USHORT          nActDraw;
    USHORT          nActView;
    BOOL            bDrag;
    BOOL            bPoly;
    Point           aDragStart;
    Point           aOldDrag;
    Polygon         aPolygon;
    Pen             aDragPen;
    Brush           aDragBrush;
    Pen             aActPen;
    Brush           aActBrush;
    Font            aActFont;
    String          aActText;
    String          aFileName;
    GDIMetaFile     aMtf;
    Printer         aPrinter;

public:
                    PaintDocWin();
                    PaintDocWin( const String& rName );
                    ~PaintDocWin();

    virtual void    MouseButtonDown( const MouseEvent& rMEvt );
    virtual void    MouseButtonUp( const MouseEvent& rMEvt );
    virtual void    MouseMove( const MouseEvent& rMEvt );
    virtual void    Paint( const Rectangle& );
    virtual BOOL    Close();
    virtual void    Activate();
    virtual void    Deactivate();

    void            Init();

    void            Load();
    void            Save();
    void            SaveAs();
    void            Print();
    void            PrintSetup();

    void            View( USHORT nView );

    BOOL            Command( USHORT nItemId );

    USHORT          GetActDraw() const { return nActDraw; }
};

#endif // _PAINTWIN_HXX
