/*************************************************************************
* SYSDEP.HXX
* Tue Jan 18 19:28:14 1994
* (c) 1992-1993 STAR DIVISION
*************************************************************************/
#ifndef _SVWIN_H
#include <svwin.h>
#endif

#ifndef _SYSDEP_HXX
#define _SYSDEP_HXX

#ifndef _SVWIN_H
#endif

class OutputDevice;
class Window;
class Menu;
class Bitmap;
class Icon;
class Pointer;
class GDIMetaFile;
class Size;
class Palette;

#define SVFEATURE_AUTOHSCROLL       ((int)0x00000001)
#define SVFEATURE_MESSBOXBEEP       ((int)0x00000002)

typedef int (*SVHOOK) ( HWND hWnd, UINT wMsg,
                        WPARAM wParam, LPARAM lParam, LRESULT& rRet );

class Sysdepen
{
public:
    static HDC          GethDC( const OutputDevice& rOutDev );
    static HWND         GethWnd( const Window& rWindow );
    static HMENU        GethMenu( const Menu& rMenu );
    static HBITMAP      GethBitmap( const Bitmap& rBitmap );
    static int          IsDIB( const Bitmap& rBitmap );
    static HICON        GethIcon( const Icon& rIcon );
    static HCURSOR      GethCursor( const Pointer& rPointer );
    static HPALETTE     GethPalette( const Palette& rPalette );

    static void         SethWnd( Window& rWindow, HWND hWnd );
    static void         SethBitmap( Bitmap& rBitmap, HBITMAP hBitmap,
                                    int bDIB = 0 );
    static void         SethIcon( Icon& rIcon, HICON hIcon,
                                  int bDestroy = FALSE );
    static void         SethCursor( Pointer& rPointer, HCURSOR hCursor,
                                    int bDestroy = FALSE );

    static HINSTANCE    GethInst();
    static HINSTANCE    GethPrevInst();
    static HWND         GethMDIClient();

    static void         SethMetaFile( GDIMetaFile& rGDIMetaFile, HMETAFILE hMF );
    static HMETAFILE    GethMetaFile( const GDIMetaFile& rGDIMetaFile );
    static void         ConvertToSysMetaFile( GDIMetaFile& rGDIMetaFile );
    static void         ConvertToSVMetaFile( GDIMetaFile& rGDIMetaFile );
    static int          IsSysMetaFile( const GDIMetaFile& rGDIMetaFile );

    static void         SetSVFeatures( int nFeatures );
    static int          GetSVFeatures();

    static SVHOOK       ChangeHook( SVHOOK pHook = 0 );
    static SVHOOK       GetHook();
};

#endif 
